/* longitudinal difference in proportions test: longp.do
   determines number of subjects per group
   power = .8 for a 2-tailed .05 test 
   
   in the 'args' statement below:
   n = number of repeated observations per subject
   icc = intraclass correlation
   p1 = proportion for group 1
   p2 = proportion for group 2
*/
args n icc p1 p2 
drop _all
set obs 1
gen za = invnormal(.975)
gen zb = invnormal(.80)
gen q1 = 1-`p1'
gen q2 = 1-`p2'
gen pbar = (`p1'+`p2')/2
gen qbar = (q1+q2)/2
gen num = ((za*sqrt(2*pbar*qbar) + zb*sqrt(`p1'*q1 + `p2'*q2))^2)*(1 + (`n'-1)*`icc')
gen den = `n'*((`p1'-`p2')^2)
gen npergrp = num/den
noisily display "number of subjects per group is " %8.2f npergrp
exit
